Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -3948,23 +6297,47 @@
 						(t3lib_extMgm::isLoaded('sys_stat') ? ',--div--,sys_stat' : '')
 					);
 
-					if (is_array($this->INSTALL['database_clearcache']))	{
-						$qList=array();
-						reset($tableListArr);
-						while(list(,$table)=each($tableListArr))	{
-							if ($table!='--div--')	{
+					if (is_array($this->INSTALL['database_clearcache'])) {
+						$qList = array();
+							// Get the template file
+						$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CheckTheDatabaseCache.html');
+							// Get the subpart for emptied tables
+						$emptiedTablesSubpart = $this->contentObject->getSubpart($templateFile, '###EMPTIEDTABLES###');
+							// Get the subpart for table
+						$tableSubpart = $this->contentObject->getSubpart($emptiedTablesSubpart, '###TABLE###');
+						foreach ($tableListArr as $table) {
+							if ($table!='--div--') {
 								$table_c = TYPO3_OS=='WIN' ? strtolower($table) : $table;
-								if ($this->INSTALL['database_clearcache'][$table] && $whichTables[$table_c])	{
+								if ($this->INSTALL['database_clearcache'][$table] && $whichTables[$table_c]) {
 									$GLOBALS['TYPO3_DB']->exec_DELETEquery($table, '');
-									$qList[] = $table;
+										// Define the markers content
+									$emptiedTablesMarkers = array(
+										'tableName' => $table
+									);
+										// Fill the markers in the subpart
+									$qList[] = $this->contentObject->substituteMarkerArray(
+										$tableSubpart,
+										$emptiedTablesMarkers,
+										'###|###',
+										1,
+										1
+									);
 								}
 							}
 						}
-						if (count($qList))	{
-							$this->message($headCode,'Clearing cache','
-							The following tables were emptied:<br /><br />
-							'.implode($qList,'<br />')
-							,1);
+							// Substitute the subpart for table
+						$emptiedTablesSubpart = $this->contentObject->substituteSubpart(
+							$emptiedTablesSubpart,
+							'###TABLE###',
+							implode(chr(10), $qList)
+						);
+
+						if (count($qList)) {
+							$this->message($headCode, 'Clearing cache', '
+								<p>
+									The following tables were emptied:
+								</p>
+							' . $emptiedTablesSubpart, 1);
 						}
 					}
 						// Count entries and make checkboxes
@@ -3987,27 +6360,71 @@
 					$checkBoxes=array();
 					$countEntries=array();
 					reset($tableListArr);
-					while(list(,$table)=each($tableListArr))	{
-						if ($table!='--div--')	{
+						// Get the template file
+					$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CheckTheDatabaseCache.html');
+						// Get the subpart for table list
+					$tableListSubpart = $this->contentObject->getSubpart($templateFile, '###TABLELIST###');
+						// Get the subpart for the group separator
+					$groupSubpart = $this->contentObject->getSubpart($tableListSubpart, '###GROUP###');
+						// Get the subpart for a single table
+					$singleTableSubpart = $this->contentObject->getSubpart($tableListSubpart, '###SINGLETABLE###');
+					$group = array();
+					$checkBoxes = array();
+					foreach ($tableListArr as $table) {
+						if ($table!='--div--') {
 							$table_c = TYPO3_OS=='WIN' ? strtolower($table) : $table;
-							if ($whichTables[$table_c])	{
+							if ($whichTables[$table_c]) {
 								$countEntries[$table] = $GLOBALS['TYPO3_DB']->exec_SELECTcountRows('*', $table);
 									// Checkboxes:
-								$checkBoxes[]= '<input type="checkbox" name="TYPO3_INSTALL[database_clearcache]['.$table.']" id="TYPO3_INSTALL[database_clearcache]['.$table.']" value="1"'.($this->INSTALL['database_clearcache'][$table]||$_GET['PRESET']['database_clearcache'][$table]?' checked="checked"':'').'> <label for="TYPO3_INSTALL[database_clearcache]['.$table.']"><strong>'.$table.'</strong> ('.$countEntries[$table].' rows) - '.$labelArr[$table].'</label>';
+								if (
+									$this->INSTALL['database_clearcache'][$table] ||
+									$_GET['PRESET']['database_clearcache'][$table]
+								) {
+									$checked = 'checked="checked"';
+								} else {
+									$checked = '';
+								}
+									// Define the markers content
+								$singleTableMarkers = array(
+									'table' => $table,
+									'checked' => $checked,
+									'count' => '(' . $countEntries[$table] . ' rows)',
+									'label' => $labelArr[$table]
+
+								);
+									// Fill the markers in the subpart
+								$checkBoxes[] = $this->contentObject->substituteMarkerArray(
+									$singleTableSubpart,
+									$singleTableMarkers,
+									'###|###',
+									1,
+									1
+								);
 							}
 						} else {
-								$checkBoxes[]= 	'<hr />';
+								$checkBoxes[] = $groupSubpart;
 						}
 					}
+						// Substitute the subpart for the single tables
+					$content = $this->contentObject->substituteSubpart(
+						$tableListSubpart,
+						'###SINGLETABLE###',
+						implode(chr(10), $checkBoxes)
+					);
+						// Substitute the subpart for the group separator
+					$content = $this->contentObject->substituteSubpart(
+						$content,
+						'###GROUP###',
+						''
+					);
 
-					$content = implode('<br />',$checkBoxes).'<br /><br />';
-
 					$form = $this->getUpdateDbFormWrap($action_type, $content);
-					$this->message($headCode,'Clear out selected tables','
-					Pressing this button will delete all records from the selected tables.<br />
-					<br />
-					'.$form.'
-					');
+					$this->message($headCode, 'Clear out selected tables', '
+						<p>
+							Pressing this button will delete all records from
+							the selected tables.
+						</p>
+					' . $form);
 				break;
 			}
 		}
@@ -4016,11 +6433,11 @@
 	}
 
 	/**
-	 * Generates update wizard, outputs it as well
+	 * Generates update wizard
 	 *
-	 * @return	void
+	 * @return void
 	 */
-	function updateWizard()	{
+	function updateWizard() {
 		global $TYPO3_CONF_VARS;
 
 			// clear cache files
@@ -4029,12 +6446,12 @@
 			// generate new cache files and include them
 		$GLOBALS['TYPO3_CONF_VARS']['EXT']['extCache'] = 1;
 		$TYPO3_LOADED_EXT = t3lib_extMgm::typo3_loadExtensions();
-		if ($TYPO3_LOADED_EXT['_CACHEFILE'])	{
-			require(PATH_typo3conf.$TYPO3_LOADED_EXT['_CACHEFILE'].'_ext_localconf.php');
+		if ($TYPO3_LOADED_EXT['_CACHEFILE']) {
+			require(PATH_typo3conf . $TYPO3_LOADED_EXT['_CACHEFILE'] . '_ext_localconf.php');
 		}
 
 			// call wizard
-		$action = ($this->INSTALL['database_type']?$this->INSTALL['database_type']:'checkForUpdate');
+		$action = ($this->INSTALL['database_type'] ? $this->INSTALL['database_type'] : 'checkForUpdate');
 		$this->updateWizard_parts($action);
 		$this->output($this->outputWrapper($this->printAll()));
 	}
@@ -4042,131 +6459,331 @@
 	/**
 	 * Implements the steps for the update wizard
 	 *
-	 * @param	string		action which should be done.
-	 * @return	void
+	 * @param string $action Which should be done.
+	 * @return void
 	 */
-	function updateWizard_parts($action)	{
+	function updateWizard_parts($action) {
 		$content = '';
-		switch ($action)	{
-			case 'checkForUpdate':	// first step - check for updates available
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'UpdateWizardParts.html');
+
+		switch ($action) {
+				// first step - check for updates available
+			case 'checkForUpdate':
+					// Get the subpart for check for update
+				$checkForUpdateSubpart = $this->contentObject->getSubpart($templateFile, '###CHECKFORUPDATE###');
 				$title = 'Step 1 - Introduction';
 				$updateWizardBoxes = '';
-				if (!$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install']['update'])	{
-					$content = '<strong>No updates registered!</strong>';
-					break;
-				}
+				if (!$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install']['update']) {
+					$updatesAvailableSubpart = '
+						<p>
+							<strong>
+								No updates registered!
+							</strong>
+						</p>
+					';
+				} else {
 
-					// step through list of updates, and check if update is needed and if yes, output an explanation
-				foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install']['update'] as $identifier => $className)	{
-					$tmpObj = $this->getUpgradeObjInstance($className, $identifier);
-					if (method_exists($tmpObj,'checkForUpdate'))	{
-						$explanation = '';
-						if ($tmpObj->checkForUpdate($explanation))	{
-							$updateWizardBoxes.= '
-								<div class="updateWizardBoxes">
-									<h3>'.$identifier.'</h3>
-									<p>'.str_replace(chr(10),'<br />',$explanation).'</p>
-									<input type="submit" name="TYPO3_INSTALL[update]['.$identifier.']" id="TYPO3_INSTALL[update]['.$identifier.']" value="Next" />
-								</div>';
+						// step through list of updates, and check if update is needed and if yes, output an explanation
+					$updatesAvailableSubpart = $this->contentObject->getSubpart($checkForUpdateSubpart, '###UPDATESAVAILABLE###');
+					$updateWizardBoxesSubpart = $this->contentObject->getSubpart($updatesAvailableSubpart, '###UPDATEWIZARDBOXES###');
+					$singleUpdateWizardBoxSubpart = $this->contentObject->getSubpart($updateWizardBoxesSubpart, '###SINGLEUPDATEWIZARDBOX###');
+					$singleUpdate = array();
+					foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install']['update'] as $identifier => $className) {
+						$tmpObj = $this->getUpgradeObjInstance($className, $identifier);
+						if (method_exists($tmpObj,'checkForUpdate')) {
+							$explanation = '';
+							if ($tmpObj->checkForUpdate($explanation)) {
+								$updateMarkers = array(
+									'identifier' => $identifier,
+									'explanation' => $explanation,
+									'next' => 'Next'
+								);
+								$singleUpdate[] = $this->contentObject->substituteMarkerArray(
+									$singleUpdateWizardBoxSubpart,
+									$updateMarkers,
+									'###|###',
+									1,
+									1
+								);
+							}
 						}
 					}
-				}
 
-				if ($updateWizardBoxes)	{
-					$updateWizardBoxes = '<table><tr><td>'.$updateWizardBoxes.'</td></tr></table>';
-					$content = '
-						<form action="'.$this->action.'#bottom" method="post">
-							<input type="hidden" name="TYPO3_INSTALL[database_type]" value="'.htmlspecialchars('getUserInput').'">
-							'.$updateWizardBoxes.'</form>';
-				} else {
-					$content = '<strong>No updates to perform!</strong>';
+					if (!empty($singleUpdate)) {
+						$updateWizardBoxesSubpart = $this->contentObject->substituteSubpart(
+							$updateWizardBoxesSubpart,
+							'###SINGLEUPDATEWIZARDBOX###',
+							implode(chr(10), $singleUpdate)
+						);
+						$updateWizardBoxesMarkers = array(
+							'action' => $this->action
+						);
+						$updateWizardBoxesSubpart = $this->contentObject->substituteMarkerArray(
+							$updateWizardBoxesSubpart,
+							$updateWizardBoxesMarkers,
+							'###|###',
+							1,
+							1
+						);
+					} else {
+						$updateWizardBoxesSubpart = '
+							<p>
+								<strong>
+									No updates to perform!
+								</strong>
+							</p>
+						';
+					}
+					$updatesAvailableSubpart = $this->contentObject->substituteSubpart(
+						$updatesAvailableSubpart,
+						'###UPDATEWIZARDBOXES###',
+						$updateWizardBoxesSubpart
+					);
+					$updatesAvailableMarkers = array(
+							'finalStep' => 'Final Step',
+							'finalStepExplanation' => '
+								<p>
+									When all updates are done you should check
+									your database for required updates.
+									<br />
+									Perform
+									<strong>
+										COMPARE DATABASE
+									</strong>
+									as often until no more changes are required.
+									<br />
+									<br />
+								</p>
+							',
+							'compareDatabase' => 'COMPARE DATABASE'
+						);
+						$updatesAvailableSubpart = $this->contentObject->substituteMarkerArray(
+							$updatesAvailableSubpart,
+							$updatesAvailableMarkers,
+							'###|###',
+							1,
+							1
+						);
 				}
-				$content .= '<table><tbody><tr><td>
-				<div class="updateWizardBoxes">
-				<h3>Final Step</h3>
-				<p>When all updates are done you should check your database for required updates.<br />
-				Perform <strong>COMPARE DATABASE</strong> as often until no more changes are required.<br /><br />
-				<input type="button" onclick="document.location.href=\'index.php?TYPO3_INSTALL[type]=database&TYPO3_INSTALL[database_type]=cmpFile|CURRENT_TABLES#bottom\';"
-				value="COMPARE DATABASE" />
-				</p>
-				</div>
-				</td></tr></tbody></table>';
+				$content = $this->contentObject->substituteSubpart(
+					$checkForUpdateSubpart,
+					'###UPDATESAVAILABLE###',
+					$updatesAvailableSubpart
+				);
 			break;
-			case 'getUserInput':	// second step - get user input and ask for final confirmation
+				// second step - get user input and ask for final confirmation
+			case 'getUserInput':
 				$title = 'Step 2 - Configuration of updates';
-				$formContent = '<p class="innerWidth"><strong>The following updates will be performed:</strong></p>';
-				if (!$this->INSTALL['update'])	{
-					$content = '<strong>No updates selected!</strong>';
+				$getUserInputSubpart = $this->contentObject->getSubpart($templateFile, '###GETUSERINPUT###');
+
+				$markers = array(
+					'introduction' => 'The following updates will be performed:',
+					'showDatabaseQueries' => 'Show database queries performed',
+					'performUpdates' => 'Perform updates!',
+					'action' => $this->action
+				);
+
+				if (!$this->INSTALL['update']) {
+					$noUpdatesAvailableSubpart = $this->contentObject->getSubpart($getUserInputSubpart, '###NOUPDATESAVAILABLE###');
+
+					$noUpdateMarkers['noUpdates'] = 'No updates selected!';
+
+					$noUpdatesAvailableSubpart = $this->contentObject->substituteMarkerArray(
+						$noUpdatesAvailableSubpart,
+						$noUpdateMarkers,
+						'###|###',
+						1,
+						1
+					);
 					break;
-				}
+				} else {
 					// update methods might need to get custom data
-				foreach ($this->INSTALL['update'] as $identifier => $tmp)	{
-					$className = $GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install']['update'][$identifier];
+					$updatesAvailableSubpart = $this->contentObject->getSubpart($getUserInputSubpart, '###UPDATESAVAILABLE###');
+					foreach ($this->INSTALL['update'] as $identifier => $tmp) {
+						$updateMarkers = array();
 
-					$tmpObj = $this->getUpgradeObjInstance($className, $identifier);
+						$className = $GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install']['update'][$identifier];
 
-					$formContent .= '<p><strong>'.$identifier.'</strong><input type="hidden" name="TYPO3_INSTALL[update][extList][]" value="'.$identifier.'" /><br />';
-					if (method_exists($tmpObj,'getUserInput'))	{
-						$formContent .= $tmpObj->getUserInput('TYPO3_INSTALL[update]['.$identifier.']');
+						$tmpObj = $this->getUpgradeObjInstance($className, $identifier);
+
+						$updateMarkers['identifier'] = $identifier;
+
+						if (method_exists($tmpObj,'getUserInput')) {
+							$updateMarkers['identifierMethod'] = $tmpObj->getUserInput('TYPO3_INSTALL[update][' . $identifier . ']');
+						}
+
+						$updateItems[] = $this->contentObject->substituteMarkerArray(
+							$updatesAvailableSubpart,
+							$updateMarkers,
+							'###|###',
+							1,
+							1
+						);
 					}
-					$formContent.= '</p>';
+					$updatesAvailableSubpart = implode(chr(10), $updateItems);
 				}
-				$formContent.= '<input type="checkbox" name="TYPO3_INSTALL[update][showDatabaseQueries]" id="TYPO3_INSTALL[update][showDatabaseQueries]" value="1" /> <label for="TYPO3_INSTALL[update][showDatabaseQueries]">Show database queries performed</label><br />';
-				$content = $this->getUpdateDbFormWrap('performUpdate', $formContent,'Perform updates!');
-			break;
+
+				$content = $this->contentObject->substituteSubpart(
+					$getUserInputSubpart,
+					'###NOUPDATESAVAILABLE###',
+					$noUpdatesAvailableSubpart
+				);
+				$content = $this->contentObject->substituteSubpart(
+					$content,
+					'###UPDATESAVAILABLE###',
+					$updatesAvailableSubpart
+				);
+				$content = $this->contentObject->substituteMarkerArray(
+					$content,
+					$markers,
+					'###|###',
+					1,
+					1
+				);
+				break;
 			case 'performUpdate':	// third step - perform update
 				$title = 'Step 3 - Perform updates';
-				if (!$this->INSTALL['update']['extList'])	{ break; }
+				$performUpdateSubpart = $this->contentObject->getSubpart($templateFile, '###PERFORMUPDATE###');
+				$updateItemsSubpart = $this->contentObject->getSubpart($performUpdateSubpart, '###UPDATEITEMS###');
+				$checkUserInputSubpart = $this->contentObject->getSubpart($updateItemsSubpart, '###CHECKUSERINPUT###');
+				$updatePerformedSubpart = $this->contentObject->getSubpart($updateItemsSubpart, '###UPDATEPERFORMED###');
+				$noPerformUpdateSubpart = $this->contentObject->getSubpart($updateItemsSubpart, '###NOPERFORMUPDATE###');
+				$databaseQueriesSubpart = $this->contentObject->getSubpart($updatePerformedSubpart, '###DATABASEQUERIES###');
+				$customOutputSubpart = $this->contentObject->getSubpart($updatePerformedSubpart, '###CUSTOMOUTPUT###');
+				if (!$this->INSTALL['update']['extList']) { break; }
 
 				$GLOBALS['TYPO3_DB']->store_lastBuiltQuery = TRUE;
-				foreach ($this->INSTALL['update']['extList'] as $identifier)	{
+				foreach ($this->INSTALL['update']['extList'] as $identifier) {
 					$className = $GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/install']['update'][$identifier];
 
 					$tmpObj = $this->getUpgradeObjInstance($className, $identifier);
-
-					$content = '<p class="innerWidth"><strong>'.$identifier.'</strong></p>';
+					$updateItemsMarkers['identifier'] = $identifier;
 						// check user input if testing method is available
-					if (method_exists($tmpObj,'checkUserInput'))	{
+					if (method_exists($tmpObj,'checkUserInput') && !$tmpObj->checkUserInput($customOutput)) {
 						$customOutput = '';
-						if (!$tmpObj->checkUserInput($customOutput))	{
-							$content.= ($customOutput?$customOutput:'Something went wrong').'<br /><br />';
-							$content.= '<a href="javascript:history.back()">Go back to update configuration</a>';
-							break;
-						}
-					}
+						$userInputMarkers = array(
+							'customOutput' => ($customOutput ? $customOutput : 'Something went wrong'),
+							'goBack' => 'Go back to update configuration'
+						);
+						$checkUserInput = $this->contentObject->substituteMarkerArray(
+							$checkUserInputSubpart,
+							$userInputMarkers,
+							'###|###',
+							1,
+							1
+						);
+					} else {
 
-					if (method_exists($tmpObj,'performUpdate'))	{
-						$customOutput = '';
-						$dbQueries = array();
-						if ($tmpObj->performUpdate($dbQueries, $customOutput))	{
-							$content .= '<strong>Update successful!</strong>';
+						if (method_exists($tmpObj,'performUpdate')) {
+							$customOutput = '';
+							$dbQueries = array();
+							if ($tmpObj->performUpdate($dbQueries, $customOutput)) {
+								$performUpdateMarkers['updateStatus'] = 'Update successful!';
+							} else {
+								$performUpdateMarkers['updateStatus'] = 'Update FAILED!';
+							}
+							if ($this->INSTALL['update']['showDatabaseQueries']) {
+								$content .= '<br />' . implode('<br />',$dbQueries);
+								foreach($dbQueries as $query) {
+									$databaseQueryMarkers['query'] = $query;
+									$databaseQueries[] = $this->contentObject->substituteMarkerArray(
+										$databaseQueriesSubpart,
+										$databaseQueryMarkers,
+										'###|###',
+										1,
+										1
+									);
+								}
+							}
+
+							if (strlen($customOutput)) {
+								$content.= '<br />' . $customOutput;
+								$customOutputMarkers['custom'] = $customOutput;
+								$customOutputItem = $this->contentObject->substituteMarkerArray(
+									$customOutputSubpart,
+									$customOutputMarkers,
+									'###|###',
+									1,
+									1
+								);
+							}
+
+							$updatePerformed = $this->contentObject->substituteSubpart(
+								$updatePerformedSubpart,
+								'###DATABASEQUERIES###',
+								implode(chr(10), $databaseQueries)
+							);
+							$updatePerformed = $this->contentObject->substituteSubpart(
+								$updatePerformed,
+								'###CUSTOMOUTPUT###',
+								$customOutputItem
+							);
+							$updatePerformed = $this->contentObject->substituteMarkerArray(
+								$updatePerformed,
+								$performUpdateMarkers,
+								'###|###',
+								1,
+								1
+							);
 						} else {
-							$content.= '<strong>Update FAILED!</strong>';
+							$noPerformUpdateMarkers['noUpdateMethod'] = 'No update method available!';
+							$noPerformUpdate = $this->contentObject->substituteMarkerArray(
+								$noPerformUpdateSubpart,
+								$noPerformUpdateMarkers,
+								'###|###',
+								1,
+								1
+							);
 						}
-						if ($this->INSTALL['update']['showDatabaseQueries'])	{
-							$content .= '<br />' . implode('<br />',$dbQueries);
-						}
-						if (strlen($customOutput))	{
-							$content.= '<br />' . $customOutput;
-						}
-					} else {
-						$content .= '<strong>No update method available!</strong>';
 					}
+					$updateItem = $this->contentObject->substituteSubpart(
+						$updateItemsSubpart,
+						'###CHECKUSERINPUT###',
+						$checkUserInput
+					);
+					$updateItem = $this->contentObject->substituteSubpart(
+						$updateItem,
+						'###UPDATEPERFORMED###',
+						$updatePerformed
+					);
+					$updateItem = $this->contentObject->substituteSubpart(
+						$updateItem,
+						'###NOPERFORMUPDATE###',
+						$noPerformUpdate
+					);
+					$updateItem = $this->contentObject->substituteSubpart(
+						$updateItem,
+						'###UPDATEITEMS###',
+						implode(chr(10), $updateItems)
+					);
+					$updateItems[] = $this->contentObject->substituteMarkerArray(
+						$updateItem,
+						$updateItemsMarkers,
+						'###|###',
+						1,
+						1
+					);
 				}
+				$content = $this->contentObject->substituteSubpart(
+					$performUpdateSubpart,
+					'###UPDATEITEMS###',
+					implode(chr(10), $updateItems)
+				);
 				$GLOBALS['TYPO3_DB']->store_lastBuiltQuery = FALSE;
 			break;
 		}
-		$this->message('Update Wizard',$title,$content);
+		$this->message('Update Wizard', $title, $content);
 	}
 
 	/**
 	 * Creates instance of an upgrade object, setting the pObj, versionNumber and pObj
 	 *
-	 * @param	string		class name
-	 * @param	identifier		identifier of upgrade object - needed to fetch user input
-	 * @return	object		newly instanciated upgrade object
+	 * @param string $className The class name
+	 * @param string $identifier The identifier of upgrade object - needed to fetch user input
+	 * @return object Newly instanciated upgrade object
 	 */
-	function getUpgradeObjInstance($className, $identifier)	{
+	function getUpgradeObjInstance($className, $identifier) {
 		$tmpObj = t3lib_div::getUserObj($className);
 		$tmpObj->versionNumber = t3lib_div::int_from_ver(TYPO3_version);
 		$tmpObj->pObj = $this;
@@ -4175,41 +6792,42 @@
 	}
 
 	/**
-	 * [Describe function...]
+	 * Check if at lease one backend admin user has been created
 	 *
-	 * @return	[type]		...
+	 * @return integer Amount of backend users in the database
 	 */
-	function isBackendAdminUser()	{
+	function isBackendAdminUser() {
 		return $GLOBALS['TYPO3_DB']->exec_SELECTcountRows('uid', 'be_users', 'admin=1');
 	}
 
 	/**
-	 * [Describe function...]
+	 * Check if static templates are available in database
 	 *
-	 * @return	[type]		...
+	 * @return integer Amount of static templates in the database
 	 */
-	function isStaticTemplates()	{
+	function isStaticTemplates() {
 		return $GLOBALS['TYPO3_DB']->exec_SELECTcountRows('uid', 'static_template');
 	}
 
 	/**
-	 * [Describe function...]
+	 * Check if the basic settings are complete
+	 * Only used by 1-2-3 mode
 	 *
-	 * @param	[type]		$tLabel: ...
-	 * @return	[type]		...
+	 * @param string $tLabel The header for the message
+	 * @return boolean TRUE if complete
 	 */
-	function isBasicComplete($tLabel)	{
-		if ($this->mode=='123')	{
+	function isBasicComplete($tLabel) {
+		if ($this->mode=='123') {
 			$tables = $this->getListOfTables();
 
-			if (count($tables))	{
+			if (count($tables)) {
 				$beuser = $this->isBackendAdminUser();
 				$static = $this->isStaticTemplates();
 			}
-			if (count($tables) && $beuser && $static)	{
+			if (count($tables) && $beuser && $static) {
 				$mode123Imported=1;
-				$this->message($tLabel,'Basic Installation Completed',nl2br($this->messageBasicFinished()),-1,1);
-				$this->message($tLabel,'Security Risk!',nl2br($this->securityRisk().$this->alterPasswordForm()),2,1);
+				$this->message($tLabel, 'Basic Installation Completed', $this->messageBasicFinished(), -1, 1);
+				$this->message($tLabel,'Security Risk!',$this->securityRisk().$this->alterPasswordForm(),2,1);
 			} else {
 				$this->message($tLabel,'Still missing something?',nl2br('
 				You may be missing one of these points before your TYPO3 installation is complete:
@@ -4230,17 +6848,18 @@
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generate the contents for the form for 'Database Analyzer'
+	 * when the 'COMPARE' still contains errors
 	 *
-	 * @param	[type]		$type: ...
-	 * @param	[type]		$arr_update: ...
-	 * @param	[type]		$arr_remove: ...
-	 * @param	[type]		$action_type: ...
-	 * @return	[type]		...
+	 * @param string $type get_form if the form needs to be generated
+	 * @param array $arr_update The tables/fields which needs an update
+	 * @param array $arr_remove The tables/fields which needs to be removed
+	 * @param string $action_type The action type
+	 * @return string HTML for the form
 	 */
-	function generateUpdateDatabaseForm($type, $arr_update, $arr_remove, $action_type)	{
+	function generateUpdateDatabaseForm($type, $arr_update, $arr_remove, $action_type) {
 		$content = '';
-		switch($type)	{
+		switch($type) {
 			case 'get_form':
 				$content.= $this->generateUpdateDatabaseForm_checkboxes($arr_update['clear_table'],'Clear tables (use with care!)',false,true);
 
